import java.util.*;

public aspect ASyncIterationCollection {
	
	tracematch(Object sync, Iterator iter) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
		
		sym sync after returning(sync):( call(* Collections.synchr*(..))) && !within(dacapo..*);
		
		sym syncCreateIter after returning(iter):( call(* Collection+.iterator()) && target(sync) && if(Thread.holdsLock(sync))) && !within(dacapo..*);			

		sym asyncCreateIter after returning(iter):( call(* Collection+.iterator()) && target(sync) && if(!Thread.holdsLock(sync))) && !within(dacapo..*);			

		//cannot but && if(!Thread.holdsLock(sync) here, due to scope limitations,
		//hence put it into advice body instead
		sym accessIter before:( call(* Iterator.*(..)) && target(iter)) && !within(dacapo..*);
		
		sync asyncCreateIter | sync syncCreateIter accessIter {
			if(!Thread.holdsLock(sync)) {
				if(System.getProperty("TMTEST_ACTIVE")!=null) {
					throw new IllegalStateException("Collection "+System.identityHashCode(sync)+
						" is synchronized. You may only iterate from within a synchronized block.");
				}
			}
		}
		
	}
			
}
