import java.util.*;

public aspect ASyncIterationMap {
	
    tracematch(Map syncMap, Set mapSet, Iterator iter) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
        
        sym sync after returning(syncMap):( call(* Collections.synchr*(..))) && !within(dacapo..*);
        
        sym createSet after returning(mapSet):( ( call(* Map.keySet()) || call(* Map.entrySet()) || call(* Map.values())) && target(syncMap)) && !within(dacapo..*);

	//cannot but && if(Thread.holdsLock(sync) here, due to scope limitations; is not a real problem, though
	sym syncCreateIter after returning(iter):( call(* Collection+.iterator()) && target(mapSet)) && !within(dacapo..*);			

	//cannot but && if(!Thread.holdsLock(sync) here, due to scope limitations,
	//hence put it into advice body instead
	sym asyncCreateIter after returning(iter):( call(* Collection+.iterator()) && target(mapSet)) && !within(dacapo..*);
		
	//cannot but && if(!Thread.holdsLock(sync) here, due to scope limitations,
	//hence put it into advice body instead
	sym accessIter before:( call(* Iterator.*(..)) && target(iter)) && !within(dacapo..*);

        sync createSet asyncCreateIter | sync createSet syncCreateIter accessIter {
            //do we hold a lock on the synchronized map?
            if(!Thread.holdsLock(syncMap)) {
                if(System.getProperty("TMTEST_ACTIVE")!=null) {
                    System.err.println("##### Tracematch "+getClass().getName()+" matched!");
               }
            }
        }
        
    }

}
