import java.util.*;

public aspect FailSafeEnum {

     pointcut vector_update() :
    	call(* Vector.add*(..)) ||
        call(* Vector.clear()) ||
        call(* Vector.insertElementAt(..)) ||
        call(* Vector.remove*(..)) ||
        call(* Vector.retainAll(..)) ||
        call(* Vector.set*(..));

     tracematch(Vector ds, Enumeration e) {
		sym newDaCapoRun before: call(* dacapo.Benchmark.run(..));
        sym create_enum after returning(e) :( ((call(* Vector+.elements()) && target(ds)) || (call(Enumeration+.new(..)) && args(ds)))) && !within(dacapo..*);
        sym call_next before :(	call(Object Enumeration.nextElement()) && target(e)) && !within(dacapo..*);
        sym update_source before :( vector_update() && target(ds)) && !within(dacapo..*);

    	create_enum call_next* update_source+ call_next
    	{
           if(System.getProperty("TMTEST_ACTIVE")!=null) {
                System.err.println("##### Tracematch "+getClass().getName()+" matched!");
           }
    	}
    }
}
   
